using Intel.UPNP;

namespace Light
{
    /// <summary>
    /// Transparent DeviceSide UPnP Service
    /// </summary>
    public class DimmingService : IUPnPService
    {

        // Place your declarations above this line

        #region AutoGenerated Code Section [Do NOT Modify, unless you know what you're doing]
        //{{{{{ Begin Code Block

        private _DimmingService _S;
        public static string URN = "urn:schemas-upnp-org:service:DimmingService:1";
        public double VERSION
        {
            get
            {
                return (double.Parse(_S.GetUPnPService().Version));
            }
        }

        public delegate void OnStateVariableModifiedHandler(DimmingService sender);
        public event OnStateVariableModifiedHandler OnStateVariableModified_LoadLevelStatus;
        public event OnStateVariableModifiedHandler OnStateVariableModified_MinLevel;
        public event OnStateVariableModifiedHandler OnStateVariableModified_MaxLevel;
        public System.Byte Evented_LoadLevelStatus
        {
            get
            {
                return ((System.Byte)_S.GetStateVariable("LoadLevelStatus"));
            }
            set
            {
                _S.SetStateVariable("LoadLevelStatus", value);
            }
        }
        public System.Byte MinLevel
        {
            get
            {
                return ((System.Byte)_S.GetStateVariable("MinLevel"));
            }
            set
            {
                _S.SetStateVariable("MinLevel", value);
            }
        }
        public System.Byte MaxLevel
        {
            get
            {
                return ((System.Byte)_S.GetStateVariable("MaxLevel"));
            }
            set
            {
                _S.SetStateVariable("MaxLevel", value);
            }
        }
        public UPnPModeratedStateVariable.IAccumulator Accumulator_LoadLevelStatus
        {
            get
            {
                return (((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("LoadLevelStatus")).Accumulator);
            }
            set
            {
                ((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("LoadLevelStatus")).Accumulator = value;
            }
        }
        public double ModerationDuration_LoadLevelStatus
        {
            get
            {
                return (((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("LoadLevelStatus")).ModerationPeriod);
            }
            set
            {
                ((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("LoadLevelStatus")).ModerationPeriod = value;
            }
        }
        public UPnPModeratedStateVariable.IAccumulator Accumulator_MinLevel
        {
            get
            {
                return (((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("MinLevel")).Accumulator);
            }
            set
            {
                ((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("MinLevel")).Accumulator = value;
            }
        }
        public double ModerationDuration_MinLevel
        {
            get
            {
                return (((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("MinLevel")).ModerationPeriod);
            }
            set
            {
                ((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("MinLevel")).ModerationPeriod = value;
            }
        }
        public UPnPModeratedStateVariable.IAccumulator Accumulator_MaxLevel
        {
            get
            {
                return (((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("MaxLevel")).Accumulator);
            }
            set
            {
                ((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("MaxLevel")).Accumulator = value;
            }
        }
        public double ModerationDuration_MaxLevel
        {
            get
            {
                return (((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("MaxLevel")).ModerationPeriod);
            }
            set
            {
                ((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("MaxLevel")).ModerationPeriod = value;
            }
        }
        public delegate System.Byte Delegate_GetLoadLevelStatus();
        public delegate System.Byte Delegate_GetMaxLevel();
        public delegate System.Byte Delegate_GetMinLevel();
        public delegate void Delegate_SetLoadLevelStatus(System.Byte newValue);

        public Delegate_GetLoadLevelStatus External_GetLoadLevelStatus = null;
        public Delegate_GetMaxLevel External_GetMaxLevel = null;
        public Delegate_GetMinLevel External_GetMinLevel = null;
        public Delegate_SetLoadLevelStatus External_SetLoadLevelStatus = null;

        public void RemoveStateVariable_LoadLevelStatus()
        {
            _S.GetUPnPService().RemoveStateVariable(_S.GetUPnPService().GetStateVariableObject("LoadLevelStatus"));
        }
        public void RemoveStateVariable_MinLevel()
        {
            _S.GetUPnPService().RemoveStateVariable(_S.GetUPnPService().GetStateVariableObject("MinLevel"));
        }
        public void RemoveStateVariable_MaxLevel()
        {
            _S.GetUPnPService().RemoveStateVariable(_S.GetUPnPService().GetStateVariableObject("MaxLevel"));
        }
        public void RemoveAction_GetLoadLevelStatus()
        {
            _S.GetUPnPService().RemoveMethod("GetLoadLevelStatus");
        }
        public void RemoveAction_GetMaxLevel()
        {
            _S.GetUPnPService().RemoveMethod("GetMaxLevel");
        }
        public void RemoveAction_GetMinLevel()
        {
            _S.GetUPnPService().RemoveMethod("GetMinLevel");
        }
        public void RemoveAction_SetLoadLevelStatus()
        {
            _S.GetUPnPService().RemoveMethod("SetLoadLevelStatus");
        }
        public System.Net.IPEndPoint GetCaller()
        {
            return (_S.GetUPnPService().GetCaller());
        }
        public System.Net.IPEndPoint GetReceiver()
        {
            return (_S.GetUPnPService().GetReceiver());
        }

        private class _DimmingService
        {
            private DimmingService Outer = null;
            private UPnPService S;
            internal _DimmingService(DimmingService n)
            {
                Outer = n;
                S = BuildUPnPService();
            }
            public UPnPService GetUPnPService()
            {
                return (S);
            }
            public void SetStateVariable(string VarName, object VarValue)
            {
                S.SetStateVariable(VarName, VarValue);
            }
            public object GetStateVariable(string VarName)
            {
                return (S.GetStateVariable(VarName));
            }
            protected UPnPService BuildUPnPService()
            {
                UPnPStateVariable[] RetVal = new UPnPStateVariable[3];
                RetVal[0] = new UPnPModeratedStateVariable("LoadLevelStatus", typeof(System.Byte), true);
                RetVal[0].DefaultValue = UPnPService.CreateObjectInstance(typeof(System.Byte), "100");
                RetVal[0].AddAssociation("GetLoadLevelStatus", "retLoadLevelStatus");
                RetVal[0].AddAssociation("SetLoadLevelStatus", "newValue");
                RetVal[1] = new UPnPModeratedStateVariable("MinLevel", typeof(System.Byte), false);
                RetVal[1].DefaultValue = UPnPService.CreateObjectInstance(typeof(System.Byte), "0");
                RetVal[1].AddAssociation("GetMinLevel", "retMinLevel");
                RetVal[2] = new UPnPModeratedStateVariable("MaxLevel", typeof(System.Byte), false);
                RetVal[2].DefaultValue = UPnPService.CreateObjectInstance(typeof(System.Byte), "100");
                RetVal[2].AddAssociation("GetMaxLevel", "retMaxLevel");

                UPnPService S = new UPnPService(1, "DimmingService.0001", "urn:schemas-upnp-org:service:DimmingService:1", true, this);
                for (int i = 0; i < RetVal.Length; ++i)
                {
                    S.AddStateVariable(RetVal[i]);
                }
                S.AddMethod("GetLoadLevelStatus");
                S.AddMethod("GetMaxLevel");
                S.AddMethod("GetMinLevel");
                S.AddMethod("SetLoadLevelStatus");
                return (S);
            }

            [Intel.UPNP.ReturnArgument("retLoadLevelStatus")]
            public System.Byte GetLoadLevelStatus()
            {
                object RetObj = null;
                if (Outer.External_GetLoadLevelStatus != null)
                {
                    RetObj = Outer.External_GetLoadLevelStatus();
                }
                else
                {
                    RetObj = Sink_GetLoadLevelStatus();
                }
                return ((System.Byte)RetObj);
            }
            [Intel.UPNP.ReturnArgument("retMaxLevel")]
            public System.Byte GetMaxLevel()
            {
                object RetObj = null;
                if (Outer.External_GetMaxLevel != null)
                {
                    RetObj = Outer.External_GetMaxLevel();
                }
                else
                {
                    RetObj = Sink_GetMaxLevel();
                }
                return ((System.Byte)RetObj);
            }
            [Intel.UPNP.ReturnArgument("retMinLevel")]
            public System.Byte GetMinLevel()
            {
                object RetObj = null;
                if (Outer.External_GetMinLevel != null)
                {
                    RetObj = Outer.External_GetMinLevel();
                }
                else
                {
                    RetObj = Sink_GetMinLevel();
                }
                return ((System.Byte)RetObj);
            }
            public void SetLoadLevelStatus(System.Byte newValue)
            {
                if (Outer.External_SetLoadLevelStatus != null)
                {
                    Outer.External_SetLoadLevelStatus(newValue);
                }
                else
                {
                    Sink_SetLoadLevelStatus(newValue);
                }
            }

            public Delegate_GetLoadLevelStatus Sink_GetLoadLevelStatus;
            public Delegate_GetMaxLevel Sink_GetMaxLevel;
            public Delegate_GetMinLevel Sink_GetMinLevel;
            public Delegate_SetLoadLevelStatus Sink_SetLoadLevelStatus;
        }
        public DimmingService()
        {
            _S = new _DimmingService(this);
            _S.GetUPnPService().GetStateVariableObject("LoadLevelStatus").OnModified += new UPnPStateVariable.ModifiedHandler(OnModifiedSink_LoadLevelStatus);
            _S.GetUPnPService().GetStateVariableObject("MinLevel").OnModified += new UPnPStateVariable.ModifiedHandler(OnModifiedSink_MinLevel);
            _S.GetUPnPService().GetStateVariableObject("MaxLevel").OnModified += new UPnPStateVariable.ModifiedHandler(OnModifiedSink_MaxLevel);
            _S.Sink_GetLoadLevelStatus = new Delegate_GetLoadLevelStatus(GetLoadLevelStatus);
            _S.Sink_GetMaxLevel = new Delegate_GetMaxLevel(GetMaxLevel);
            _S.Sink_GetMinLevel = new Delegate_GetMinLevel(GetMinLevel);
            _S.Sink_SetLoadLevelStatus = new Delegate_SetLoadLevelStatus(SetLoadLevelStatus);
        }
        public DimmingService(string ID)
            : this()
        {
            _S.GetUPnPService().ServiceID = ID;
        }
        public UPnPService GetUPnPService()
        {
            return (_S.GetUPnPService());
        }
        private void OnModifiedSink_LoadLevelStatus(UPnPStateVariable sender, object NewValue)
        {
            if (OnStateVariableModified_LoadLevelStatus != null) OnStateVariableModified_LoadLevelStatus(this);
        }
        private void OnModifiedSink_MinLevel(UPnPStateVariable sender, object NewValue)
        {
            if (OnStateVariableModified_MinLevel != null) OnStateVariableModified_MinLevel(this);
        }
        private void OnModifiedSink_MaxLevel(UPnPStateVariable sender, object NewValue)
        {
            if (OnStateVariableModified_MaxLevel != null) OnStateVariableModified_MaxLevel(this);
        }
        //}}}}} End of Code Block

        #endregion

        /// <summary>
        /// Action: GetLoadLevelStatus
        /// </summary>
        /// <returns>Associated StateVariable: LoadLevelStatus</returns>
        public System.Byte GetLoadLevelStatus()
        {
            return Evented_LoadLevelStatus;
        }
        /// <summary>
        /// Action: GetMaxLevel
        /// </summary>
        /// <returns>Associated StateVariable: MaxLevel</returns>
        public System.Byte GetMaxLevel()
        {
            return 100;
        }
        /// <summary>
        /// Action: GetMinLevel
        /// </summary>
        /// <returns>Associated StateVariable: MinLevel</returns>
        public System.Byte GetMinLevel()
        {
            return 0;
        }
        /// <summary>
        /// Action: SetLoadLevelStatus
        /// </summary>
        /// <param name="newValue">Associated State Variable: LoadLevelStatus</param>
        public void SetLoadLevelStatus(System.Byte newValue)
        {
            Evented_LoadLevelStatus = newValue;
        }
    }
}