﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;

using System.Net;
using System.Net.Sockets;

namespace Light
{
    static class Program
    {
        /// <summary>
        /// Point d'entrée principal de l'application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            int port = 50002;

            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Form1 form = new Form1();
            SampleDevice device = new SampleDevice(form);
            form.setDevice(device);
            try
            {
                device.Start(port);
                Application.Run(form);
            }
            catch (SocketException)
            {
                MessageBox.Show("UPnP Light already running on this host", "Device already in use",
                                MessageBoxButtons.OK, MessageBoxIcon.Warning);
            }
            device.Stop();
            Application.Exit();
        }
    }
}
