using Intel.UPNP;

namespace Light
{
    /// <summary>
    /// Transparent DeviceSide UPnP Service
    /// </summary>
    public class SwitchPower : IUPnPService
    {

        // Place your declarations above this line

        #region AutoGenerated Code Section [Do NOT Modify, unless you know what you're doing]
        //{{{{{ Begin Code Block

        private _SwitchPower _S;
        public static string URN = "urn:schemas-upnp-org:service:SwitchPower:1";
        public double VERSION
        {
            get
            {
                return (double.Parse(_S.GetUPnPService().Version));
            }
        }

        public delegate void OnStateVariableModifiedHandler(SwitchPower sender);
        public event OnStateVariableModifiedHandler OnStateVariableModified_Status;
        public System.Boolean Evented_Status
        {
            get
            {
                return ((System.Boolean)_S.GetStateVariable("Status"));
            }
            set
            {
                _S.SetStateVariable("Status", value);
            }
        }
        public UPnPModeratedStateVariable.IAccumulator Accumulator_Status
        {
            get
            {
                return (((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("Status")).Accumulator);
            }
            set
            {
                ((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("Status")).Accumulator = value;
            }
        }
        public double ModerationDuration_Status
        {
            get
            {
                return (((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("Status")).ModerationPeriod);
            }
            set
            {
                ((UPnPModeratedStateVariable)_S.GetUPnPService().GetStateVariableObject("Status")).ModerationPeriod = value;
            }
        }
        public delegate System.Boolean Delegate_GetStatus();
        public delegate void Delegate_Off();
        public delegate void Delegate_On();
        public delegate void Delegate_SetStatus(System.Boolean newValue);

        public Delegate_GetStatus External_GetStatus = null;
        public Delegate_Off External_Off = null;
        public Delegate_On External_On = null;
        public Delegate_SetStatus External_SetStatus = null;

        public void RemoveStateVariable_Status()
        {
            _S.GetUPnPService().RemoveStateVariable(_S.GetUPnPService().GetStateVariableObject("Status"));
        }
        public void RemoveAction_GetStatus()
        {
            _S.GetUPnPService().RemoveMethod("GetStatus");
        }
        public void RemoveAction_Off()
        {
            _S.GetUPnPService().RemoveMethod("Off");
        }
        public void RemoveAction_On()
        {
            _S.GetUPnPService().RemoveMethod("On");
        }
        public void RemoveAction_SetStatus()
        {
            _S.GetUPnPService().RemoveMethod("SetStatus");
        }
        public System.Net.IPEndPoint GetCaller()
        {
            return (_S.GetUPnPService().GetCaller());
        }
        public System.Net.IPEndPoint GetReceiver()
        {
            return (_S.GetUPnPService().GetReceiver());
        }

        private class _SwitchPower
        {
            private SwitchPower Outer = null;
            private UPnPService S;
            internal _SwitchPower(SwitchPower n)
            {
                Outer = n;
                S = BuildUPnPService();
            }
            public UPnPService GetUPnPService()
            {
                return (S);
            }
            public void SetStateVariable(string VarName, object VarValue)
            {
                S.SetStateVariable(VarName, VarValue);
            }
            public object GetStateVariable(string VarName)
            {
                return (S.GetStateVariable(VarName));
            }
            protected UPnPService BuildUPnPService()
            {
                UPnPStateVariable[] RetVal = new UPnPStateVariable[1];
                RetVal[0] = new UPnPModeratedStateVariable("Status", typeof(System.Boolean), true);
                RetVal[0].AddAssociation("GetStatus", "retStatus");
                RetVal[0].AddAssociation("SetStatus", "newValue");

                UPnPService S = new UPnPService(1, "SwitchPower.0001", "urn:schemas-upnp-org:service:SwitchPower:1", true, this);
                for (int i = 0; i < RetVal.Length; ++i)
                {
                    S.AddStateVariable(RetVal[i]);
                }
                S.AddMethod("GetStatus");
                S.AddMethod("Off");
                S.AddMethod("On");
                S.AddMethod("SetStatus");
                return (S);
            }

            [Intel.UPNP.ReturnArgument("retStatus")]
            public System.Boolean GetStatus()
            {
                object RetObj = null;
                if (Outer.External_GetStatus != null)
                {
                    RetObj = Outer.External_GetStatus();
                }
                else
                {
                    RetObj = Sink_GetStatus();
                }
                return ((System.Boolean)RetObj);
            }
            public void Off()
            {
                if (Outer.External_Off != null)
                {
                    Outer.External_Off();
                }
                else
                {
                    Sink_Off();
                }
            }
            public void On()
            {
                if (Outer.External_On != null)
                {
                    Outer.External_On();
                }
                else
                {
                    Sink_On();
                }
            }
            public void SetStatus(System.Boolean newValue)
            {
                if (Outer.External_SetStatus != null)
                {
                    Outer.External_SetStatus(newValue);
                }
                else
                {
                    Sink_SetStatus(newValue);
                }
            }

            public Delegate_GetStatus Sink_GetStatus;
            public Delegate_Off Sink_Off;
            public Delegate_On Sink_On;
            public Delegate_SetStatus Sink_SetStatus;
        }
        public SwitchPower()
        {
            _S = new _SwitchPower(this);
            _S.GetUPnPService().GetStateVariableObject("Status").OnModified += new UPnPStateVariable.ModifiedHandler(OnModifiedSink_Status);
            _S.Sink_GetStatus = new Delegate_GetStatus(GetStatus);
            _S.Sink_Off = new Delegate_Off(Off);
            _S.Sink_On = new Delegate_On(On);
            _S.Sink_SetStatus = new Delegate_SetStatus(SetStatus);
        }
        public SwitchPower(string ID)
            : this()
        {
            _S.GetUPnPService().ServiceID = ID;
        }
        public UPnPService GetUPnPService()
        {
            return (_S.GetUPnPService());
        }
        private void OnModifiedSink_Status(UPnPStateVariable sender, object NewValue)
        {
            if (OnStateVariableModified_Status != null) OnStateVariableModified_Status(this);
        }
        //}}}}} End of Code Block

        #endregion

        /// <summary>
        /// Action: GetStatus
        /// </summary>
        /// <returns>Associated StateVariable: Status</returns>
        public System.Boolean GetStatus()
        {
            return Evented_Status;
        }
        /// <summary>
        /// Action: Off
        /// </summary>
        public void Off()
        {
            Evented_Status = false;
        }
        /// <summary>
        /// Action: On
        /// </summary>
        public void On()
        {
            Evented_Status = true;
        }
        /// <summary>
        /// Action: SetStatus
        /// </summary>
        /// <param name="newValue">Associated State Variable: Status</param>
        public void SetStatus(System.Boolean newValue)
        {
            Evented_Status = newValue;
        }
    }
}